uniform vec3 blaster0;
uniform vec3 blaster1;
uniform vec3 blaster2;
uniform float elapsedTime;

varying vec3 vPosition;
varying vec3 vNormal;
varying vec2 vUv;
varying vec3 e;
varying vec3 n;
varying float vBlast;

float a1 = 0.204724;
float p1 = 0.267717;
float p2 = 0.181102;
float p3 = 0.133858;
float o1 = 42.5;
float o2 = 85.0;
float wobbleScale = 0.068643;

float wobble(float x) {
    return ((a1* sin(p1 * x) * a1*2.0*sin(p2*0.5*(x+o1)) * a1*4.0*sin(p3*0.25*(x+o2))) + wobbleScale) / (2.0*wobbleScale);
}

vec3 wobbleVec(float offx, float offy, float offz) {
	vec3 v = vec3(0.0);
	v.x = wobble((elapsedTime * 0.95 + offx) * 10.0) * 2.0 - 1.0;
	v.y = wobble((elapsedTime * 0.97 + offy) * 10.0) * 2.0 - 1.0;
	v.z = wobble((elapsedTime * 1.12 + offz) * 10.0) * 2.0 - 1.0;
	return v;
}



void main() {
	vPosition = position;
	vNormal = normal;
	vUv = uv.xy;

	e = normalize( vec3( modelViewMatrix * vec4( position, 1.0 ) ) );
    n = normalize( normalMatrix * normal );

	gl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );

	float blast0 = 1.0 - smoothstep(0.0, 0.7, length(position - blaster0));
	float blast1 = 1.0 - smoothstep(0.0, 0.6, length(position - blaster1));
	float blast2 = 1.0 - smoothstep(0.0, 0.5, length(position - blaster2));
	vBlast = clamp(blast0 + blast1 + blast2, 0.0, 1.0);
}